package fi.cc.android;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class GameClientActivity extends Activity implements ConnectionCallback{
	private static final String MESSAGE_KEY = null;
	private EditText addressEditText;
	private EditText portEditText;
	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
     // turn off the window's title bar
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.client);
        
        Button connectButton=(Button) findViewById(R.id.connect);
        Button cancelClientButton=(Button) findViewById(R.id.cancelclient);
        
        addressEditText=(EditText)findViewById(R.id.ServerAddress);
        portEditText=(EditText)findViewById(R.id.ClientPortEditText);
        
        
        CommonObjects.connection_engine=new ConnectionEngine();
		CommonObjects.connection_engine.setCallBack(this);
        
		connectButton.setOnClickListener (new OnClickListener(){

			@Override
			public void onClick(View v) {
				CommonObjects.connection_engine.createConnection(addressEditText.getText().toString(), Integer.parseInt(portEditText.getText().toString()));
			}
        });
        
        cancelClientButton.setOnClickListener(new OnClickListener(){

			@Override
			public void onClick(View v) {
				Intent MainIntent = new Intent(getApplicationContext(),RaceDroidActivity.class);
				startActivity(MainIntent);
				
			}
        });
        
        
    }

	@Override
	public void connectionCreated() {
		Intent StartGameIntent = new Intent(getApplicationContext(),GameMainActivity.class);
        CommonObjects.isMultiplayer=true;
        startActivity(StartGameIntent);
		
	}

	@Override
	public void dataMessage(byte[] msg) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void infoMessage(String msg) {
		Message message = new Message();
		Bundle bundle=new Bundle();
		
		bundle.putString(MESSAGE_KEY, msg);
		message.setData(bundle);
		messageHandler.sendMessage(message);
		
	}
	private Handler messageHandler = new Handler() {

	      @Override
	      public void handleMessage(Message msg) {  
	    	  Bundle bundle = msg.getData();
	    	  
	    	  if (bundle!=null && bundle.containsKey(MESSAGE_KEY)){
	    		  Toast.makeText(getBaseContext(), bundle.getString(MESSAGE_KEY), Toast.LENGTH_LONG).show();
	    		  
	    	  }
	      }
	 };

	@Override
	public void startGame() {
		// TODO Auto-generated method stub
		
	}
}
