package fi.cc.android;


import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.Paint.Style;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.AttributeSet;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.widget.Toast;

public class RaceDroidView extends SurfaceView implements ConnectionCallback{
	private static final byte COORDINATE_MESSAGE = 100;
	private static final byte MAPINFO_MESSAGE = 101;
	private static final byte START_MESSAGE = 102;
	private static final byte READY_MESSAGE = 103;
	protected static final String MESSAGE_KEY = "message_key";
	private static final double TOP_SPEED_X = 150;
	private static final double TOP_SPEED_Y = 80;
	//private Drawable copter;
	private Context context;
	private long startTime;
	double elapsedTime;
	private int cX,cY=0;
	private double ySpeed=0;
	private int xSpeed=0;
	private double t1,t2=0;
	private int screen_height=320;
	private int screen_width=480;
	private Canvas canvas;
	private RaceDroidThread thread;
    private SurfaceHolder mSurfaceHolder;
	private boolean mUp;
	private boolean mDown;
	private boolean mLeft;
	private boolean mRight;
	private int gravity = (int) PhysicsConstants.g;
	private double power = PhysicsConstants.power;
	private double movepower = PhysicsConstants.movepower;
	public SpaceShip spaceShip1;
	public SpaceShip opponentShip;
	private ArrayList<Integer> Px;
	private ArrayList<Integer> Py1;
	private ArrayList<Integer> Py2;
	private Paint mLinePaint;
	private int myX;
	private int flightSpeed=PhysicsConstants.flight_speed;
	private int startPoint=1;
	private int tunnel_length=4800;
	private int tunnel_npoints=50;
	private int tunnel_space=130;
	private boolean shouldRun=true;
	private String elapsedS="";
	private int hitCount;	
	private ConnectionEngine connection;
	boolean multiplayer=false;
	private boolean gameIsFinished=false;
	private boolean paused=false;
	private boolean mCenter;
	private Object mutex=new Object();
	long mLastTime;
	boolean firstdraw=true;
	
	

	public RaceDroidThread getThread() {
		return thread;
	}
	public void setMultiPlayer(boolean arg){
		multiplayer=arg;
	}

	class RaceDroidThread extends Thread {
		
		
		public RaceDroidThread(){
			Resources res = context.getResources();
	        spaceShip1=new SpaceShip(0, 0, 0, context.getResources().getDrawable(R.drawable.copter));
	        opponentShip=new SpaceShip(0, 0, 0, context.getResources().getDrawable(R.drawable.copter2));
			//copter = context.getResources().getDrawable(R.drawable.copter);
	        Px = MyGameTools.createX(tunnel_length, tunnel_npoints);
	        Py2 = MyGameTools.createY2(screen_height, tunnel_npoints, tunnel_space);
	        Py1 = MyGameTools.createY1(screen_height, tunnel_npoints, tunnel_space, Py2);
	        //Painter ------------------------------------
			mLinePaint = new Paint();
			mLinePaint.setStyle(Style.FILL_AND_STROKE);
	        mLinePaint.setAntiAlias(true);
	        mLinePaint.setARGB(255, 0, 255, 0);
	        mLinePaint.setStrokeWidth(3);
	        mLinePaint.setTextSize(15);
	        mLinePaint.setFakeBoldText(true); 
	        connection=CommonObjects.connection_engine;
	        
	        
	       if(multiplayer && connection.isServer ){
	    	   	try {
					this.sleep(1000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				connection.sendMessage(createMapInfoMessage());
				/*byte[] msg=new byte[50];
				
				msg[0]=START_MESSAGE;
				connection.sendMessage(msg);
				this.start();*/
			}
	       if(!multiplayer)
	    	   this.start();
	        

		}
		@Override
		public void run() {
			
			t1 = System.currentTimeMillis();
			Log.d(this.getClass().getName(),screen_height+"");
			while (shouldRun){
				if(paused && !multiplayer)
					try {
						synchronized (mutex) {
							mutex.wait();
							
						}
					} catch (InterruptedException e2) {
						// TODO Auto-generated catch block
						e2.printStackTrace();
					}

				
				Canvas c = null;
                try {
					c = mSurfaceHolder.lockCanvas(null);
					canvas = c;
					synchronized (mSurfaceHolder) {
						updatePhysics();
						connection.sendMessage(createCoordinateMessage());
						
						doDraw(c);
					}
				} catch (Exception e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}finally{
					if (c != null) {
                        mSurfaceHolder.unlockCanvasAndPost(c);
                        canvas=null;
                    }
				}
				try {
					Thread.currentThread().sleep(10);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		
	}

	public RaceDroidView(Context context) {
		super(context);
		this.context = context;
		thread = new RaceDroidThread();
		mSurfaceHolder = getHolder();
        setFocusable(true); // make sure we get key events
		// TODO Auto-generated constructor stub
        connection=CommonObjects.connection_engine;
        
        if (connection==null){
        	connection=new ConnectionEngine();
        }
        connection.setCallBack(this);
      
	}
	

	public RaceDroidView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		this.context = context;
		thread = new RaceDroidThread();
		mSurfaceHolder = getHolder();
        setFocusable(true); // make sure we get key events
        connection=CommonObjects.connection_engine;
        
        if (connection==null){
        	connection=new ConnectionEngine();
        }
        connection.setCallBack(this);
       
// TODO Auto-generated constructor stub
	}

	public RaceDroidView(Context context, AttributeSet attrs) {
		super(context, attrs);
		this.context = context;
		thread = new RaceDroidThread();
		mSurfaceHolder = getHolder();
        this.setFocusable(true); // make sure we get key events
        connection=CommonObjects.connection_engine;
        
        if (connection==null){
        	connection=new ConnectionEngine();
        }
        connection.setCallBack(this);
     
		// TODO Auto-generated constructor stub
	}

	public void updatePhysics() {
		int lastX=spaceShip1.x;
		int lastY=spaceShip1.y;
		double lastdX=spaceShip1.dx;
		double lastdY=spaceShip1.dy;
		double ddx=0,ddy=0;
		if(firstdraw){
			mLastTime=System.currentTimeMillis();
			firstdraw=false;
			spaceShip1.x=mSurfaceHolder.getSurfaceFrame().centerX();
			spaceShip1.y=mSurfaceHolder.getSurfaceFrame().centerY();
		}
		
		if(canvas == null){
			startTime = System.currentTimeMillis();
			t1=startTime;
			return;
		}
		long now = System.currentTimeMillis();
		elapsedS = ((now-startTime)/1000)+"."+((now-startTime) % 1000);
		
		if (mLastTime > now) return;
        
        double elapsed = (now - mLastTime) / 1000.0;
        
        
		if(mLeft){
			ddx-=8000*elapsed;
        	//spaceShip1.dx+=1;
		}
        if(mRight){
        	ddx+=5000*elapsed;
        	//spaceShip1.dx-=1;
        }
        if(mUp){
        	ddy-=5000*elapsed;
        	//spaceShip1.dy+=1;
        }
        if(mDown){
        	ddy+=5000*elapsed;
        	//spaceShip1.dy-=1;
        }
        //Gravity
        ddy+=500*elapsed;
        
        //Slow down if not accelerating
        if(ddx==0){
        	if(spaceShip1.dx>0)
        		ddx-=1000*elapsed;
        	else if(spaceShip1.dx<0)
        		ddx+=1000*elapsed;
        }
        if(ddy==0){
        	if(spaceShip1.dy>0)
        		ddy-=1000*elapsed;
        	else if(spaceShip1.dy<0)
        		ddy+=1000*elapsed;
        }
        
        
        spaceShip1.dx+=ddx*elapsed;
        if(spaceShip1.dx<0)
        	spaceShip1.dx=0;
        if(spaceShip1.dx>TOP_SPEED_X)
        	spaceShip1.dx=TOP_SPEED_X;
        
        spaceShip1.dy+=ddy*elapsed;
        if(spaceShip1.dy>TOP_SPEED_Y)
        	spaceShip1.dy=TOP_SPEED_Y;
        else if(spaceShip1.dy<-TOP_SPEED_Y)
        	spaceShip1.dy=-TOP_SPEED_Y; 
        
        spaceShip1.x+=(spaceShip1.dx+lastdX)/2*elapsed;
        
        spaceShip1.y+=(spaceShip1.dy+lastdY)/2*elapsed;
        if(spaceShip1.y+spaceShip1.height<0)
        	spaceShip1.y=spaceShip1.height;
        if(spaceShip1.y>screen_height)
        	spaceShip1.y=screen_height;
        
        mLastTime=now;
		/*
		gravity+=0.2;
        spaceShip1.y += gravity;
        
        if(mLeft){
        	movepower+=0.3;
        	spaceShip1.x-=movepower;
        	if(flightSpeed>PhysicsConstants.flight_speed){
        		flightSpeed-=(flightSpeed/3);
        	}
        }
        if(mRight){
        	movepower+=0.5;
        	spaceShip1.x+=movepower;
        	if(flightSpeed<2*PhysicsConstants.flight_speed)
        		flightSpeed++;
        }
        if(mUp){
        	gravity = (int) PhysicsConstants.g;
        	power+=0.4;
        	spaceShip1.y-=power;
        }
        if(mDown)
        	spaceShip1.y+=1;
        */
/*        if(spaceShip1.x>screen_width/2){
        	flightSpeed+=(spaceShip1.x-(screen_width/2))/50;
        }
*/        
        
       /* if(spaceShip1.y < 0) spaceShip1.y = 0;
        if(spaceShip1.y > screen_height-spaceShip1.height) spaceShip1.y = screen_height-spaceShip1.height;
        
        if(spaceShip1.x==100 && spaceShip1.y==0){
        	//this.thread.stop();
        	shouldRun=false;
        	((Activity)(getContext())).finish();
        }*/
		/*if(cY<screen_height && cY>=0){
			ySpeed+=PhysicsConstants.g;
			if(mUp){
				ySpeed-=PhysicsConstants.power;
			}
			cY+=(int)ySpeed;*/
/*			long now = System.currentTimeMillis();
			double T1= (t1-startTime)/1000.0;
			double T2= ((double)now - startTime)/1000.0;
			//Log.d(">>>>>>","T2="+T2+"T1="+T1);
			int gravity=PhysicsConstants.g;
			
			int Y1 = ((int)(0.5 * gravity * T1 * T1));
			int Y2 = ((int)(0.5 * gravity * T2 * T2));
			
			int deltaY = Y2 - Y1;
			
			if(mUp){
				Log.d(">>>>>>","gravitiy:"+gravity);				
				gravity -= (int)(0.25 * gravity);
			}else{
				if(gravity<0)
				gravity+=(int)(0.25 * gravity);
			} 
			cY+= deltaY; 
			t1=now;

			
			}
*/
        
	}

	
	@Override
	    public boolean onKeyDown(int keyCode, KeyEvent msg) {
	    	 boolean handled = false;

	         synchronized (mSurfaceHolder) {
	                 if (keyCode == KeyEvent.KEYCODE_DPAD_UP){
	                	 //System.out.println(">>>> UP pressed");
	                	 mUp=true;
	                	 handled=true;
	                 }
	                 else if (keyCode==KeyEvent.KEYCODE_DPAD_DOWN){
	                	 mDown=true;
	                	 handled=true;
	                 }
	                 else if (keyCode==KeyEvent.KEYCODE_DPAD_LEFT){
	                	 mLeft=true;
	                	 handled=true;
	                	 movepower = PhysicsConstants.movepower;
	                 }
	                 else if (keyCode==KeyEvent.KEYCODE_DPAD_RIGHT){
	                	 mRight=true;
	                	 handled=true;
	                	 movepower = PhysicsConstants.movepower;
	                 }
	                 else if (keyCode==KeyEvent.KEYCODE_DPAD_CENTER){
	                	 mCenter=true;
	                	 handled=true;
	                 }
	                		 
	         }

	         return handled;
	    }

	   @Override
	    public boolean onKeyUp(int keyCode, KeyEvent msg) {
	    	boolean handled = false;

	        synchronized (mSurfaceHolder) {
	                if (keyCode == KeyEvent.KEYCODE_DPAD_UP){
	               	 mUp=false;
	               	 handled=true;
	               	 power = PhysicsConstants.power;
                	 //System.out.println(">>>> UP released");

	                }
	                else if (keyCode==KeyEvent.KEYCODE_DPAD_DOWN){
	               	 mDown=false;
	               	 handled=true;
	                }
	                else if (keyCode==KeyEvent.KEYCODE_DPAD_LEFT){
	               	 mLeft=false;
	               	 handled=true;
	                }
	                else if (keyCode==KeyEvent.KEYCODE_DPAD_RIGHT){
	               	 mRight=false;
	               	 handled=true;
	                }
	                else if (keyCode==KeyEvent.KEYCODE_DPAD_CENTER ){
	                	 mCenter=true;
	                	 handled=true;
	                	 if(!multiplayer){
	                	 paused=!paused;
	                	 if (!paused){
	                		if(!gameIsFinished){
	 						synchronized (mutex) {
								mutex.notify();
							}
	                		}else{
	                			shouldRun=false;
	                			((Activity)getContext()).finish();
	                		}
	                	  }
	                	 }else{
	                		if(gameIsFinished){
	                			shouldRun=false;
	                			((Activity)getContext()).finish();
	                		}
	                			
	                	  }
	                 }
 
	        }

	        return handled;
	    }
	private void fillPath(){
		int i;
		Path pathUpper=new Path();
		Path pathLower=new Path();
		pathUpper.moveTo((float) Px.get(0)-myX, (float)Py1.get(0));
		pathLower.moveTo((float) Px.get(0)-myX, (float)Py2.get(0));
		
		for(i=1;i< Px.size();i++){
			pathUpper.lineTo((float) Px.get(i)-myX, (float)Py1.get(i));
    		pathLower.lineTo((float) Px.get(i)-myX, (float)Py2.get(i));
		}
		pathUpper.lineTo((float) Px.get(i)-myX, (float) 0.0);
		pathUpper.lineTo((float) Px.get(0)-myX, (float) 0.0);
		pathUpper.close();
		pathLower.lineTo((float) Px.get(i)-myX, (float) 320.0);
		pathLower.lineTo((float) Px.get(0)-myX, (float) 320.0);
		pathLower.close();
	}
	
	public void doDraw(Canvas c){
		int first=0;
		//if(cY>screen_height) return;

		if(spaceShip1.image!=null && c!=null && Px!=null){
		c.drawColor(Color.BLACK);
		int oldPaintWidth=(int) mLinePaint.getStrokeWidth();
		mLinePaint.setStrokeWidth(1);
		//mLinePaint.setStrokeWidth(oldPaintWidth);
        //myX+=flightSpeed ;
        myX=spaceShip1.x-screen_width/2;
        Paint mCavePaint = new Paint();
        mCavePaint.setARGB(255, 100, 100, 100);
        int i;
//        for(i=0;i< Px.size();i++){
//        	if(i+1<Px.size() && (Px.get(i)<myX && Px.get(i+1)>myX) || i==0 ){
//        		pathUpper.moveTo((float) Px.get(i)-myX, (float)Py1.get(i));
//        		pathLower.moveTo((float) Px.get(i)-myX, (float)Py2.get(i));
//        		first=i;
//        		for(int j=i+1;j<Px.size();j++){
//        			pathUpper.lineTo((float) Px.get(j)-myX, (float)Py1.get(j));
//            		pathLower.lineTo((float) Px.get(j)-myX, (float)Py2.get(j));
//            		if(Px.get(j)>myX+screen_width){
//            			pathUpper.lineTo((float) Px.get(i)-myX, (float) 0.0);
//            			pathUpper.lineTo((float) Px.get(first)-myX, (float) 0.0);
//            			pathUpper.close();
//            			pathLower.lineTo((float) Px.get(i)-myX, (float) 320.0);
//                		pathLower.lineTo((float) Px.get(first)-myX, (float) 320.0);
//                		pathLower.close();
//            			break;
//            		}
//        		}
//        		break;
//        	}
//        	if(i+1<Px.size() && Px.get(i)>myX && Px.get(i+1)<myX+screen_width){
//        		pathUpper.lineTo((float) Px.get(i)-myX, (float)Py1.get(i));
//        		pathLower.lineTo((float) Px.get(i)-myX, (float)Py2.get(i));
//        	}
//        	if(i>0 && Px.get(i-1)<myX+screen_width && Px.get(i)>myX+screen_width){
//        		pathUpper.lineTo((float) Px.get(i)-myX, (float)Py1.get(i));
//        		pathUpper.lineTo((float) Px.get(i)-myX, (float) 0.0);
//        		pathUpper.lineTo((float) Px.get(first)-myX, (float) 0.0);
//        		pathUpper.close();
//        		pathLower.lineTo((float) Px.get(i)-myX, (float)Py2.get(i));
//        		pathLower.lineTo((float) Px.get(i)-myX, (float) 320.0);
//        		pathLower.lineTo((float) Px.get(first)-myX, (float) 320.0);
//        		pathLower.close();
//        		break;
//        	}
//        }

        
        boolean b = true;
        for (i = startPoint; i < Px.size(); i++)	{
        	Path pathUpper=new Path();
    		Path pathLower=new Path();
        	pathUpper.moveTo((float) Px.get(i)-myX, (float)Py2.get(i));
        	pathUpper.lineTo((float) Px.get(i+1)-myX, (float)Py2.get(i+1));
        	pathUpper.lineTo((float) Px.get(i+2)-myX, (float)Py2.get(i+2));
        	pathUpper.lineTo((float) Px.get(i+2)-myX, (float) 0.0);
       		
        	pathUpper.lineTo((float) Px.get(i)-myX, (float) 0.0);
        	pathUpper.close();
       		canvas.drawPath(pathUpper,mCavePaint);
//       		canvas.drawLine(Px.get(i-1)-myX, Py1.get(i-1), Px.get(i)-myX, Py1.get(i), mLinePaint);
//       		canvas.drawLine(Px.get(i-1)-myX, Py2.get(i-1), Px.get(i)-myX, Py2.get(i), mLinePaint);
       		Path path = new Path();
       		pathLower.moveTo((float) Px.get(i)-myX, (float)Py1.get(i));
       		pathLower.lineTo((float) Px.get(i+1)-myX, (float)Py1.get(i+1));
       		pathLower.lineTo((float) Px.get(i+2)-myX, (float)Py1.get(i+2));
       		pathLower.lineTo((float) Px.get(i+2)-myX, (float) 320.0);
       		
       		pathLower.lineTo((float) Px.get(i)-myX, (float) 320.0);
       		pathLower.close();
       		canvas.drawPath(pathLower,mCavePaint);
        
       		
			
       		//----- check Crash --------------------------
   			if(Px.get(i)-myX > spaceShip1.x-myX && i > 1 &b  ){
   					canvas.drawCircle((float)(Px.get(i)-myX), (float)Py1.get(i), 10.0f, mLinePaint);
   					
   					canvas.drawCircle((float)(Px.get(i)-myX), (float)Py2.get(i), 10.0f, mLinePaint);
					
   					if (!MyGameTools.higherThanLineCheck(spaceShip1.x-myX, spaceShip1.y, Px.get(i)-myX, Px.get(i-1)-myX, Py1.get(i), Py1.get(i-1))){						
						spaceShip1.hitcounter++;
						//spaceShip1.x=30;
						spaceShip1.y = MyGameTools.lineY(spaceShip1.x-myX,  Px.get(i)-myX, Px.get(i-1)-myX, Py1.get(i), Py1.get(i-1)) -3; 
					}

   					if (MyGameTools.higherThanLineCheck(spaceShip1.x-myX, spaceShip1.y+spaceShip1.image.getIntrinsicHeight(), Px.get(i)-myX, Px.get(i-1)-myX, Py2.get(i), Py2.get(i-1))){						
   						spaceShip1.hitcounter++;
   						spaceShip1.y = MyGameTools.lineY(spaceShip1.x-myX,  Px.get(i)-myX, Px.get(i-1)-myX, Py2.get(i), Py2.get(i-1))+3;
						//spaceShip1.x=30;
					}
					canvas.drawCircle(spaceShip1.x-myX, MyGameTools.lineY(spaceShip1.x-myX,  Px.get(i)-myX, Px.get(i-1)-myX, Py1.get(i), Py1.get(i-1)), 5.0f, mLinePaint);
					canvas.drawCircle(spaceShip1.x-myX, MyGameTools.lineY(spaceShip1.x-myX,  Px.get(i)-myX, Px.get(i-1)-myX, Py2.get(i), Py2.get(i-1)), 5.0f, mLinePaint);
					
					b=false;
				}
       		//-----------------------------------------

       		if (Px.get(i)-myX > 480) // Px.get(i)+myX < 0 || 
       		{
       			startPoint=i-(tunnel_length / screen_width);
       			if(startPoint<1) startPoint=1;
           		break;
       		}	
       		/*int g;
       		for( g=0; g<Px.size();g++){
       			if(spaceShip1.x>Px.get(g) && spaceShip1.x>Px.get(g+1))
       				break;
       		}*/
       		
       		/*if(MyGameTools.higherThanLineCheck(spaceShip1.x, spaceShip1.y, Px.get(g), Px.get(g+1), Py1.get(g), Py1.get(g+1))){
       			spaceShip1.dx=0; 
        		hitCount++;
       		}*/
//       		if(spaceShip1.y + spaceShip1.height > ((Py2.get(i+2)+Py2.get(i+1))/2)) {
//        		//spaceShip1.y = Py2.get(i+2) - spaceShip1.height;
//       			//spaceShip1.dx=0;
//        		hitCount++;
//	        }
//	        if(spaceShip1.y < ((Py1.get(i+2)+Py1.get(i+1))/2)) { 
//	    		//spaceShip1.y = Py1.get(i+2) ;
//	        	//spaceShip1.dx=0;
//	    		hitCount++;
//	        }
        
//	        float kulmakerroin = (Py2.get(i)-Py2.get(i-1))/(Px.get(i)-Px.get(i-1));
//	        int dx = spaceShip1.x+spaceShip1.width - Px.get(i-1);
//	        int y0 = (int)Py2.get(i-1)+(int)(kulmakerroin*dx);
//	        if (spaceShip1.y+spaceShip1.height > y0)  
//	        	{
//	        	//spaceShip1.y = y0-spaceShip1.height;
//	        	hitCount++;
//	        	}
	        
       		c.drawText  ("Time Elapsed: "+elapsedS + " hitCount: " + spaceShip1.hitcounter +", " +spaceShip1.x + ", "+ spaceShip1.y +", "+ Px.get(Px.size()-1), 0, 20, mLinePaint);
    		
       }
        
        //c.drawText  ("Time Elapsed: "+elapsedS + " hitCount: " + hitCount+", " +spaceShip1.x + ", "+ spaceShip1.y +", "+ Px.get(Px.size()-1), 0, 20, mLinePaint);
        
        if(Px.get(Px.size()-10)-spaceShip1.x<0){
			mLinePaint.setTextSize(30);
   			c.drawText  ("Game Over" , screen_width/2, screen_height/2, mLinePaint);
			gameIsFinished = true;
			paused=true; 
			
		}
		spaceShip1.image.setBounds(spaceShip1.x-myX,spaceShip1.y
				,spaceShip1.x-myX+spaceShip1.image.getIntrinsicWidth()
				,spaceShip1.y+spaceShip1.image.getIntrinsicHeight());
		spaceShip1.image.draw(c);
		
		if (multiplayer){
			opponentShip.image.setBounds(opponentShip.x-myX,opponentShip.y
					,opponentShip.x-myX+opponentShip.image.getIntrinsicWidth()
					,opponentShip.y+opponentShip.image.getIntrinsicHeight());
			opponentShip.image.draw(c);
			}
		}
	}
	
	private byte[] createCoordinateMessage(){
    	byte[] msg=new byte[10];
    	
    	
    	msg[0]=COORDINATE_MESSAGE;
    	//X
    	msg[1] = (byte) ((spaceShip1.x >> 24) & 0xff);
    	msg[2] = (byte) ((spaceShip1.x >> 16) & 0xff);
    	msg[3] = (byte) ((spaceShip1.x >> 8) & 0xff);
    	msg[4] = (byte) ((spaceShip1.x) & 0xff);
    	//y
    	msg[5] = (byte) ((spaceShip1.y >> 24) & 0xff);
    	msg[6] = (byte) ((spaceShip1.y >> 16) & 0xff);
    	msg[7] = (byte) ((spaceShip1.y >> 8) & 0xff);
    	msg[8] = (byte) ((spaceShip1.y) & 0xff);
    	
    	return msg;
    }
	private byte[] createMapInfoMessage(){
		byte[] msg=new byte[3*4*Px.size()+1];
		int location=0;
		int bytelocation=0;
		int tmpInt=0;
		
		msg[location]=MAPINFO_MESSAGE;
		location++;
		for (int i=0;i<Px.size();i++){
			tmpInt=Px.get(i);
			
			msg[location] = (byte) ((tmpInt >> 24) & 0xff);
			location++;
			msg[location] = (byte) ((tmpInt >> 16) & 0xff);
			location++;
			msg[location] = (byte) ((tmpInt >> 8) & 0xff);
			location++;
			msg[location] = (byte) ((tmpInt) & 0xff);
			location++;
		}
		for (int i=0;i<Py1.size();i++){
			tmpInt=Py1.get(i);
			bytelocation=0;
			msg[location] = (byte) ((tmpInt >> 24) & 0xff);
			location++;
			msg[location] = (byte) ((tmpInt >> 16) & 0xff);
			location++;
			msg[location] = (byte) ((tmpInt >> 8) & 0xff);
			location++;
			msg[location] = (byte) ((tmpInt) & 0xff);
			location++;
		}
		for (int i=0;i<Py2.size();i++){
			tmpInt=Py2.get(i);
			msg[location] = (byte) ((tmpInt >> 24) & 0xff);
			location++;
			msg[location] = (byte) ((tmpInt >> 16) & 0xff);
			location++;
			msg[location] = (byte) ((tmpInt >> 8) & 0xff);
			location++;
			msg[location] = (byte) ((tmpInt) & 0xff);
			location++;
		}
		
		return msg;
	}
	private byte[] packIntegers(ArrayList<Integer> integers,byte[] bytes, int offset){
		int location=0;
		int tmpInt=0;
		
		tmpInt=integers.get(location);
		for (int i=0;i<integers.size();i++){
			tmpInt=integers.get(i);
			location=0;
			bytes[offset+i+location] = (byte) ((tmpInt >> 24) & 0xff);
			location++;
			bytes[offset+i+location] = (byte) ((tmpInt >> 16) & 0xff);
			location++;
			bytes[offset+i+location] = (byte) ((tmpInt >> 8) & 0xff);
			location++;
			bytes[offset+i+location] = (byte) ((tmpInt) & 0xff);
		}
		
		return bytes;
	}
    
    void unPackCoordinateMessage(byte[] msg){
    	byte[] tmpInt=new byte[4];
    	int location=1;
    	
    	for (int i=0;i<4;i++){
    		tmpInt[i]=msg[location];
    		location++;
    	}
    	opponentShip.x=getInt(tmpInt);
    	for (int i=0;i<4;i++){
    		tmpInt[i]=msg[location];
    		location++;
    	}
    	opponentShip.y=getInt(tmpInt);
    	//System.out.println("nNew location" + opponentShip.x + ", "+opponentShip.y);
    }
    
    void unPackMap(byte[] msg){
    	byte[] tmpInt=new byte[4];
    	int location=1;
    	int size=Px.size();
    	Px.clear();
    	Py1.clear();
    	Py2.clear();
    	for(int j=0; j<size;j++){
	    	for (int i=0;i<4;i++){
	    		tmpInt[i]=msg[location];
	    		location++;
	    	}
	    	if(Px!=null){
	    		//Px.remove(j);
	    		Px.add(j, getInt(tmpInt));
	    	}
    	}
    	for(int j=0; j<size;j++){
	    	for (int i=0;i<4;i++){
	    		tmpInt[i]=msg[location];
	    		location++;
	    	}
	    	if(Py1!=null){
	    		//Py1.remove(j);
	    		Py1.add(j, getInt(tmpInt));
	    	}
    	}
    	for(int j=0; j<size;j++){
	    	for (int i=0;i<4;i++){
	    		tmpInt[i]=msg[location];
	    		location++;
	    	}
	    	if(Py2!=null){
	    		//Py2.remove(j);
	    		Py2.add(j, getInt(tmpInt));
	    	}
    	}
    	byte[] rspmsg=new byte[50];
		
		rspmsg[0]=READY_MESSAGE;
		connection.sendMessage(rspmsg);
		
    }
    
    private int getInt (byte[] buf){
    	if (buf == null) {
    		return -1;
    	}
      	if (buf.length!= 4) {
      		 return -1;
      	}
      	int r=0;
      	
      	for (int i =0; i<buf.length; i++){
      		r <<= 8; 
      		r |= (buf [i] & 0x000000ff);
      	}
      	return r;
    }
        
    public void dataMessage(byte[] msg) {
		/*Message message = new Message();
		Bundle bundle=new Bundle();
		
		bundle.putString(MESSAGE_KEY, msg);
		message.setData(bundle);
		messageHandler.sendMessage(message);
		*/
		//Toast.makeText(getBaseContext(), msg, Toast.LENGTH_LONG).show();
    	if(msg[0]==COORDINATE_MESSAGE){
    		unPackCoordinateMessage(msg);
    	}
    	else if(msg[0]==MAPINFO_MESSAGE){
    		unPackMap(msg);
    	}
    	else if(msg[0]==START_MESSAGE){
    		startGame();
    	}
    	else if(msg[0]==READY_MESSAGE){
    		byte[] rspmsg=new byte[50];
    		
    		rspmsg[0]=START_MESSAGE;
    		connection.sendMessage(rspmsg);
    		startGame();
    	}
	}

	public void infoMessage(String msg) {
		Message message = new Message();
		Bundle bundle=new Bundle();
		
		bundle.putString(MESSAGE_KEY, msg);
		message.setData(bundle);
		messageHandler.sendMessage(message);
		//Toast.makeText(getBaseContext(), msg, Toast.LENGTH_LONG).show();
	}
	
	@Override
	public void connectionCreated() {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void startGame() { 
		
		mLastTime = System.currentTimeMillis();
		spaceShip1.x=mSurfaceHolder.getSurfaceFrame().centerX();
		spaceShip1.y=mSurfaceHolder.getSurfaceFrame().centerY();
		spaceShip1.dx=0;
		thread.start();
	}
	
	 private Handler messageHandler = new Handler() {

	      @Override
	      public void handleMessage(Message msg) {  
	    	  Bundle bundle = msg.getData();
	    	  
	    	  if (bundle!=null && bundle.containsKey(MESSAGE_KEY)){
	    		  Toast.makeText(getContext(), bundle.getString(MESSAGE_KEY), Toast.LENGTH_LONG).show();
	    		  
	    	  }
	      }
	 };


	

}
